> ## Documentation Index
> Fetch the complete documentation index at: https://docs.firedrill.run/llms.txt
> Use this file to discover all available pages before exploring further.

# Read a saved browser test

> Requires authoring.read. Reads the current active saved version; already-created runs retain their own immutable snapshots.



## OpenAPI

````yaml /api-reference/openapi.json get /v1/projects/{projectId}/browser-tests/{testId}
openapi: 3.1.0
info:
  title: Firedrill Control API
  version: 1.0.0
  description: >-
    The control plane for drills, drill runs, and the worlds they run in. Errors
    always carry the canonical envelope; unsafe operations require an
    Idempotency-Key; long work returns an operation resource.
servers:
  - url: https://api.firedrill.run
security:
  - controlCredential: []
paths:
  /v1/projects/{projectId}/browser-tests/{testId}:
    get:
      tags:
        - browser-tests
      summary: Read a saved browser test
      description: >-
        Requires authoring.read. Reads the current active saved version;
        already-created runs retain their own immutable snapshots.
      operationId: browserTests.get
      parameters:
        - name: projectId
          in: path
          required: true
          schema:
            type: string
            pattern: ^prj_[0-9a-z]{12,32}$
        - name: testId
          in: path
          required: true
          schema:
            type: string
            pattern: ^btest_[a-z0-9]{12,64}$
      responses:
        '200':
          description: Read a saved browser test
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/SavedHostedBrowserTest'
        '400':
          description: Canonical error envelope
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorEnvelope'
        '401':
          description: Canonical error envelope
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorEnvelope'
        '403':
          description: Canonical error envelope
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorEnvelope'
        '404':
          description: Canonical error envelope
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorEnvelope'
        '409':
          description: Canonical error envelope
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorEnvelope'
        '429':
          description: Canonical error envelope
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorEnvelope'
        default:
          description: Canonical error envelope
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorEnvelope'
components:
  schemas:
    SavedHostedBrowserTest:
      type: object
      properties:
        schemaVersion:
          type: number
          enum:
            - 1
        testId:
          type: string
          pattern: ^btest_[a-z0-9]{12,64}$
        organizationId:
          type: string
        projectId:
          type: string
        definition:
          type: object
          properties:
            schemaVersion:
              type: number
              enum:
                - 1
            id:
              type: string
              pattern: ^[A-Za-z0-9][A-Za-z0-9._-]{0,95}$
            title:
              type: string
              minLength: 1
              maxLength: 200
            startUrl:
              type: string
              maxLength: 4000
              format: uri
            task:
              type: string
              minLength: 1
              maxLength: 20000
            steps:
              default: []
              maxItems: 500
              type: array
              items:
                anyOf:
                  - type: object
                    properties:
                      action:
                        type: string
                        enum:
                          - navigate
                      url:
                        type: string
                        minLength: 1
                        maxLength: 4000
                    required:
                      - action
                      - url
                    additionalProperties: false
                  - type: object
                    properties:
                      action:
                        type: string
                        enum:
                          - click
                      selector:
                        anyOf:
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - role
                              role:
                                type: string
                                enum:
                                  - button
                                  - link
                                  - textbox
                                  - checkbox
                                  - radio
                                  - combobox
                                  - option
                                  - heading
                                  - alert
                                  - status
                                  - tab
                                  - menuitem
                              name:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - role
                              - name
                            additionalProperties: false
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - label
                              value:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - value
                            additionalProperties: false
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - text
                              value:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - value
                            additionalProperties: false
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - testId
                              value:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - value
                            additionalProperties: false
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - css
                              value:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - value
                            additionalProperties: false
                    required:
                      - action
                      - selector
                    additionalProperties: false
                  - type: object
                    properties:
                      action:
                        type: string
                        enum:
                          - fill
                      selector:
                        anyOf:
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - role
                              role:
                                type: string
                                enum:
                                  - button
                                  - link
                                  - textbox
                                  - checkbox
                                  - radio
                                  - combobox
                                  - option
                                  - heading
                                  - alert
                                  - status
                                  - tab
                                  - menuitem
                              name:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - role
                              - name
                            additionalProperties: false
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - label
                              value:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - value
                            additionalProperties: false
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - text
                              value:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - value
                            additionalProperties: false
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - testId
                              value:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - value
                            additionalProperties: false
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - css
                              value:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - value
                            additionalProperties: false
                      value:
                        type: string
                        maxLength: 20000
                      parameter:
                        type: string
                        pattern: ^[A-Za-z0-9][A-Za-z0-9._-]{0,95}$
                    required:
                      - action
                      - selector
                    additionalProperties: false
                  - type: object
                    properties:
                      action:
                        type: string
                        enum:
                          - press
                      selector:
                        anyOf:
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - role
                              role:
                                type: string
                                enum:
                                  - button
                                  - link
                                  - textbox
                                  - checkbox
                                  - radio
                                  - combobox
                                  - option
                                  - heading
                                  - alert
                                  - status
                                  - tab
                                  - menuitem
                              name:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - role
                              - name
                            additionalProperties: false
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - label
                              value:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - value
                            additionalProperties: false
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - text
                              value:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - value
                            additionalProperties: false
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - testId
                              value:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - value
                            additionalProperties: false
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - css
                              value:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - value
                            additionalProperties: false
                      key:
                        type: string
                        minLength: 1
                        maxLength: 80
                    required:
                      - action
                      - selector
                      - key
                    additionalProperties: false
                  - type: object
                    properties:
                      action:
                        type: string
                        enum:
                          - wait
                      milliseconds:
                        type: integer
                        minimum: 0
                        maximum: 10000
                    required:
                      - action
                      - milliseconds
                    additionalProperties: false
            assertions:
              default: []
              maxItems: 100
              type: array
              items:
                anyOf:
                  - type: object
                    properties:
                      id:
                        type: string
                        pattern: ^[A-Za-z0-9][A-Za-z0-9._-]{0,95}$
                      kind:
                        type: string
                        enum:
                          - visible
                      selector:
                        anyOf:
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - role
                              role:
                                type: string
                                enum:
                                  - button
                                  - link
                                  - textbox
                                  - checkbox
                                  - radio
                                  - combobox
                                  - option
                                  - heading
                                  - alert
                                  - status
                                  - tab
                                  - menuitem
                              name:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - role
                              - name
                            additionalProperties: false
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - label
                              value:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - value
                            additionalProperties: false
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - text
                              value:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - value
                            additionalProperties: false
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - testId
                              value:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - value
                            additionalProperties: false
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - css
                              value:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - value
                            additionalProperties: false
                      expected:
                        default: true
                        type: boolean
                    required:
                      - id
                      - kind
                      - selector
                      - expected
                    additionalProperties: false
                  - type: object
                    properties:
                      id:
                        type: string
                        pattern: ^[A-Za-z0-9][A-Za-z0-9._-]{0,95}$
                      kind:
                        type: string
                        enum:
                          - text
                      selector:
                        anyOf:
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - role
                              role:
                                type: string
                                enum:
                                  - button
                                  - link
                                  - textbox
                                  - checkbox
                                  - radio
                                  - combobox
                                  - option
                                  - heading
                                  - alert
                                  - status
                                  - tab
                                  - menuitem
                              name:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - role
                              - name
                            additionalProperties: false
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - label
                              value:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - value
                            additionalProperties: false
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - text
                              value:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - value
                            additionalProperties: false
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - testId
                              value:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - value
                            additionalProperties: false
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - css
                              value:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - value
                            additionalProperties: false
                      expected:
                        type: string
                        maxLength: 20000
                      contains:
                        default: false
                        type: boolean
                    required:
                      - id
                      - kind
                      - selector
                      - expected
                      - contains
                    additionalProperties: false
                  - type: object
                    properties:
                      id:
                        type: string
                        pattern: ^[A-Za-z0-9][A-Za-z0-9._-]{0,95}$
                      kind:
                        type: string
                        enum:
                          - value
                      selector:
                        anyOf:
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - role
                              role:
                                type: string
                                enum:
                                  - button
                                  - link
                                  - textbox
                                  - checkbox
                                  - radio
                                  - combobox
                                  - option
                                  - heading
                                  - alert
                                  - status
                                  - tab
                                  - menuitem
                              name:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - role
                              - name
                            additionalProperties: false
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - label
                              value:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - value
                            additionalProperties: false
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - text
                              value:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - value
                            additionalProperties: false
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - testId
                              value:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - value
                            additionalProperties: false
                          - type: object
                            properties:
                              by:
                                type: string
                                enum:
                                  - css
                              value:
                                type: string
                                minLength: 1
                                maxLength: 4000
                            required:
                              - by
                              - value
                            additionalProperties: false
                      expected:
                        type: string
                        maxLength: 20000
                    required:
                      - id
                      - kind
                      - selector
                      - expected
                    additionalProperties: false
                  - type: object
                    properties:
                      id:
                        type: string
                        pattern: ^[A-Za-z0-9][A-Za-z0-9._-]{0,95}$
                      kind:
                        type: string
                        enum:
                          - url
                      expected:
                        type: string
                        minLength: 1
                        maxLength: 4000
                    required:
                      - id
                      - kind
                      - expected
                    additionalProperties: false
          required:
            - schemaVersion
            - id
            - startUrl
            - steps
            - assertions
          additionalProperties: false
        version:
          type: integer
          minimum: 0
          exclusiveMinimum: true
          maximum: 9007199254740991
        createdAtMs:
          type: integer
          minimum: -9007199254740991
          maximum: 9007199254740991
        updatedAtMs:
          type: integer
          minimum: -9007199254740991
          maximum: 9007199254740991
        deletedAtMs:
          type: integer
          minimum: -9007199254740991
          maximum: 9007199254740991
      required:
        - schemaVersion
        - testId
        - organizationId
        - projectId
        - definition
        - version
        - createdAtMs
        - updatedAtMs
      additionalProperties: false
    ErrorEnvelope:
      type: object
      properties:
        code:
          type: string
          pattern: ^(control|world)\.[A-Z][A-Z0-9]*(_[A-Z0-9]+)*$
        message:
          type: string
          minLength: 1
        correlationId:
          type: string
          minLength: 1
        retryable:
          type: boolean
        retryAfterMs:
          type: integer
          exclusiveMinimum: 0
          maximum: 9007199254740991
        operationId:
          type: string
        source:
          type: string
          enum:
            - platform
            - simulated_provider
        issues:
          type: array
          items:
            type: object
            properties:
              path:
                type: string
              code:
                type: string
              message:
                type: string
            required:
              - path
              - code
              - message
            additionalProperties: false
        details:
          type: object
          propertyNames:
            type: string
          additionalProperties: {}
        evidence:
          type: object
          properties:
            sessionId:
              type: string
            runId:
              type: string
            journalSeq:
              type: integer
              minimum: 0
              maximum: 9007199254740991
            buildHash:
              type: string
          additionalProperties: false
      required:
        - code
        - message
        - correlationId
        - retryable
        - source
      additionalProperties: true
  securitySchemes:
    controlCredential:
      type: http
      scheme: bearer
      description: Opaque control credential

````